/* -*- Mode: C -*-
 *
 * File: gfsmapply_cmdparser.h
 * Description: Headers for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.07.
 *
 */

#ifndef gfsmapply_cmdparser_h
#define gfsmapply_cmdparser_h

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * moocow: Never set PACKAGE and VERSION here.
 */

struct gengetopt_args_info {
  int words_flag;	 /* INPUT(s) are words to lookup, not filenames. (default=0). */
  char * ilabels_arg;	 /* Specify input (lower) labels file. (default=NULL). */
  char * olabels_arg;	 /* Specify output (upper) labels file. (default=NULL). */
  char * labels_arg;	 /* Set -i and -o labels simultaneously. (default=NULL). */
  int att_mode_flag;	 /* Parse/format string(s) in AT&T-compatible mode. (default=0). */
  int utf8_flag;	 /* Assume UTF-8 encoded alphabet(s) and input(s). (default=0). */
  int quiet_flag;	 /* Suppress warnings about undefined symbols. (default=0). */
  char * fst_arg;	 /* Transducer to apply (default=stdin). (default=-). */
  int maxq_arg;	 /* Maximum number of result states to generate (default=0:system limit) (default=0). */
  int align_flag;	 /* Output aligned arc paths. (default=0). */
  int compress_arg;	 /* Specify compression level of output file. (default=-1). */
  char * output_arg;	 /* Specifiy output file (default=stdout). (default=-). */

  int help_given;	 /* Whether help was given */
  int version_given;	 /* Whether version was given */
  int words_given;	 /* Whether words was given */
  int ilabels_given;	 /* Whether ilabels was given */
  int olabels_given;	 /* Whether olabels was given */
  int labels_given;	 /* Whether labels was given */
  int att_mode_given;	 /* Whether att-mode was given */
  int utf8_given;	 /* Whether utf8 was given */
  int quiet_given;	 /* Whether quiet was given */
  int fst_given;	 /* Whether fst was given */
  int maxq_given;	 /* Whether maxq was given */
  int align_given;	 /* Whether align was given */
  int compress_given;	 /* Whether compress was given */
  int output_given;	 /* Whether output was given */
  
  char **inputs;         /* unnamed arguments */
  unsigned inputs_num;   /* number of unnamed arguments */
};

/* read rc files (if any) and parse all command-line options in one swell foop */
int  cmdline_parser (int argc, char *const *argv, struct gengetopt_args_info *args_info);

/* instantiate defaults from environment variables: you must call this yourself! */
void cmdline_parser_envdefaults (struct gengetopt_args_info *args_info);

/* read a single rc-file */
void cmdline_parser_read_rcfile (const char *filename,
				    struct gengetopt_args_info *args_info,
				    int user_specified);

/* read a single rc-file (stream) */
void cmdline_parser_read_rc_stream (FILE *rcfile,
				       const char *filename,
				       struct gengetopt_args_info *args_info);

/* parse a single option */
int cmdline_parser_parse_option (char oshort, const char *olong, const char *val,
				    struct gengetopt_args_info *args_info);

/* print help message */
void cmdline_parser_print_help(void);

/* print version */
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* gfsmapply_cmdparser_h */
