/* -*- Mode: C -*-
 *
 * File: gfsmencode_cmdparser.h
 * Description: Headers for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.07.
 *
 */

#ifndef gfsmencode_cmdparser_h
#define gfsmencode_cmdparser_h

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * moocow: Never set PACKAGE and VERSION here.
 */

struct gengetopt_args_info {
  int decode_flag;	 /* Decode an encoded automaton (default: encode) (default=0). */
  int costs_flag;	 /* Encode/decode costs (weights); encodes as unweighted automaton. (default=0). */
  int labels_flag;	 /* Encode/decode labels (pairs); encodes as acceptor. (default=0). */
  int reuse_key_flag;	 /* Re-use existing KEYFILE in encoding mode. (default=0). */
  int update_key_flag;	 /* Update an existing KEYFILE in encoding mode. (default=0). */
  int compress_arg;	 /* Specify compression level of output file. (default=-1). */
  char * output_arg;	 /* Specifiy output file (default=stdout). (default=-). */

  int help_given;	 /* Whether help was given */
  int version_given;	 /* Whether version was given */
  int decode_given;	 /* Whether decode was given */
  int costs_given;	 /* Whether costs was given */
  int labels_given;	 /* Whether labels was given */
  int reuse_key_given;	 /* Whether reuse-key was given */
  int update_key_given;	 /* Whether update-key was given */
  int compress_given;	 /* Whether compress was given */
  int output_given;	 /* Whether output was given */
  
  char **inputs;         /* unnamed arguments */
  unsigned inputs_num;   /* number of unnamed arguments */
};

/* read rc files (if any) and parse all command-line options in one swell foop */
int  cmdline_parser (int argc, char *const *argv, struct gengetopt_args_info *args_info);

/* instantiate defaults from environment variables: you must call this yourself! */
void cmdline_parser_envdefaults (struct gengetopt_args_info *args_info);

/* read a single rc-file */
void cmdline_parser_read_rcfile (const char *filename,
				    struct gengetopt_args_info *args_info,
				    int user_specified);

/* read a single rc-file (stream) */
void cmdline_parser_read_rc_stream (FILE *rcfile,
				       const char *filename,
				       struct gengetopt_args_info *args_info);

/* parse a single option */
int cmdline_parser_parse_option (char oshort, const char *olong, const char *val,
				    struct gengetopt_args_info *args_info);

/* print help message */
void cmdline_parser_print_help(void);

/* print version */
void cmdline_parser_print_version(void);

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* gfsmencode_cmdparser_h */
