/* -*- Mode: C -*-
 *
 * File: gfsmstrings_cmdparser.c
 * Description: Code for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.07
 * generated with the following command:
 * /usr/local/bin/optgen.perl -u -l --no-handle-rcfile --nopod -F gfsmstrings_cmdparser gfsmstrings.gog
 *
 * The developers of optgen.perl consider the fixed text that goes in all
 * optgen.perl output files to be in the public domain:
 * we make no copyright claims on it.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

/* If we use autoconf/autoheader.  */
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#ifdef HAVE_PWD_H
# include <pwd.h>
#endif

/* Allow user-overrides for PACKAGE and VERSION */
#ifndef PACKAGE
#  define PACKAGE "PACKAGE"
#endif

#ifndef VERSION
#  define VERSION "VERSION"
#endif


#ifndef PROGRAM
# define PROGRAM "gfsmstrings"
#endif

/* #define cmdline_parser_DEBUG */

/* Check for "configure's" getopt check result.  */
#ifndef HAVE_GETOPT_LONG
# include "getopt.h"
#else
# include <getopt.h>
#endif

#include "gfsmstrings_cmdparser.h"


/* user code section */

/* end user  code section */


void
cmdline_parser_print_version (void)
{
  printf("gfsmstrings (%s %s) by Bryan Jurish <moocow.bovine@gmail.com>\n", PACKAGE, VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n");
  printf("Purpose:\n");
  printf("  Serialize binary acyclic gfsm files to lists of strings\n");
  printf("\n");
  
  printf("Usage: %s [OPTIONS]... BINFILE\n", "gfsmstrings");
  
  printf("\n");
  printf(" Arguments:\n");
  printf("   BINFILE  Stored binary gfsm file\n");
  
  printf("\n");
  printf(" Options:\n");
  printf("   -h         --help            Print help and exit.\n");
  printf("   -V         --version         Print version and exit.\n");
  printf("\n");
  printf(" Common Options:\n");
  printf("   -iLABELS   --ilabels=LABELS  Specify input (lower) labels file.\n");
  printf("   -oLABELS   --olabels=LABELS  Specify output (upper) labels file.\n");
  printf("   -lLABELS   --labels=LABELS   Set -i and -o labels simultaneously.\n");
  printf("   -qLABELS   --qlabels=LABELS  Specify state labels file (for -align mode).\n");
  printf("   -Q         --show-states     Show numeric states in -align mode output\n");
  printf("   -a         --att             Output in AT&T regex format.\n");
  printf("   -A         --align           Output aligned arc paths.\n");
  printf("   -v         --viterbi         Treat input automaton as a Viterbi trellis.\n");
  printf("   -u         --utf8            Assume UTF-8 encoded alphabet and input\n");
  printf("   -FTXTFILE  --output=TXTFILE  Output file.\n");
}

#if defined(HAVE_STRDUP) || defined(strdup)
# define gog_strdup strdup
#else
/* gog_strdup(): automatically generated from strdup.c. */
/* strdup.c replacement of strdup, which is not standard */
static char *
gog_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}
#endif /* HAVE_STRDUP */

/* clear_args(args_info): clears all args & resets to defaults */
static void
clear_args(struct gengetopt_args_info *args_info)
{
  args_info->ilabels_arg = NULL; 
  args_info->olabels_arg = NULL; 
  args_info->labels_arg = NULL; 
  args_info->qlabels_arg = NULL; 
  args_info->show_states_flag = 0; 
  args_info->att_flag = 0; 
  args_info->align_flag = 0; 
  args_info->viterbi_flag = 0; 
  args_info->utf8_flag = 0; 
  args_info->output_arg = NULL; 
}


int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0;
  args_info->version_given = 0;
  args_info->ilabels_given = 0;
  args_info->olabels_given = 0;
  args_info->labels_given = 0;
  args_info->qlabels_given = 0;
  args_info->show_states_given = 0;
  args_info->att_given = 0;
  args_info->align_given = 0;
  args_info->viterbi_given = 0;
  args_info->utf8_given = 0;
  args_info->output_given = 0;

  clear_args(args_info);

  /* rcfile handling */
  
  /* end rcfile handling */

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
	{ "help", 0, NULL, 'h' },
	{ "version", 0, NULL, 'V' },
	{ "ilabels", 1, NULL, 'i' },
	{ "olabels", 1, NULL, 'o' },
	{ "labels", 1, NULL, 'l' },
	{ "qlabels", 1, NULL, 'q' },
	{ "show-states", 0, NULL, 'Q' },
	{ "att", 0, NULL, 'a' },
	{ "align", 0, NULL, 'A' },
	{ "viterbi", 0, NULL, 'v' },
	{ "utf8", 0, NULL, 'u' },
	{ "output", 1, NULL, 'F' },
        { NULL,	0, NULL, 0 }
      };
      static char short_options[] = {
	'h',
	'V',
	'i', ':',
	'o', ':',
	'l', ':',
	'q', ':',
	'Q',
	'a',
	'A',
	'v',
	'u',
	'F', ':',
	'\0'
      };

      c = getopt_long (argc, argv, short_options, long_options, &option_index);

      if (c == -1) break;	/* Exit from 'while (1)' loop.  */

      if (cmdline_parser_parse_option(c, long_options[option_index].name, optarg, args_info) != 0) {
	exit (EXIT_FAILURE);
      }
    } /* while */

  

  if ( missing_required_options )
    exit (EXIT_FAILURE);

  
  if (optind < argc) {
      int i = 0 ;
      args_info->inputs_num = argc - optind ;
      args_info->inputs = (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gog_strdup (argv[optind++]) ; 
  }

  return 0;
}


/* Parse a single option */
int
cmdline_parser_parse_option(char oshort, const char *olong, const char *val,
			       struct gengetopt_args_info *args_info)
{
  if (!oshort && !(olong && *olong)) return 1;  /* ignore null options */

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "parse_option(): oshort='%c', olong='%s', val='%s'\n", oshort, olong, val);*/
#endif

  switch (oshort)
    {
      case 'h':	 /* Print help and exit. */
          if (args_info->help_given) {
            fprintf(stderr, "%s: `--help' (`-h') option given more than once\n", PROGRAM);
          }
          clear_args(args_info);
          cmdline_parser_print_help();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'V':	 /* Print version and exit. */
          if (args_info->version_given) {
            fprintf(stderr, "%s: `--version' (`-V') option given more than once\n", PROGRAM);
          }
          clear_args(args_info);
          cmdline_parser_print_version();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'i':	 /* Specify input (lower) labels file. */
          if (args_info->ilabels_given) {
            fprintf(stderr, "%s: `--ilabels' (`-i') option given more than once\n", PROGRAM);
          }
          args_info->ilabels_given++;
          if (args_info->ilabels_arg) free(args_info->ilabels_arg);
          args_info->ilabels_arg = gog_strdup(val);
          break;
        
        case 'o':	 /* Specify output (upper) labels file. */
          if (args_info->olabels_given) {
            fprintf(stderr, "%s: `--olabels' (`-o') option given more than once\n", PROGRAM);
          }
          args_info->olabels_given++;
          if (args_info->olabels_arg) free(args_info->olabels_arg);
          args_info->olabels_arg = gog_strdup(val);
          break;
        
        case 'l':	 /* Set -i and -o labels simultaneously. */
          if (args_info->labels_given) {
            fprintf(stderr, "%s: `--labels' (`-l') option given more than once\n", PROGRAM);
          }
          args_info->labels_given++;
          if (args_info->labels_arg) free(args_info->labels_arg);
          args_info->labels_arg = gog_strdup(val);
          break;
        
        case 'q':	 /* Specify state labels file (for -align mode). */
          if (args_info->qlabels_given) {
            fprintf(stderr, "%s: `--qlabels' (`-q') option given more than once\n", PROGRAM);
          }
          args_info->qlabels_given++;
          if (args_info->qlabels_arg) free(args_info->qlabels_arg);
          args_info->qlabels_arg = gog_strdup(val);
          break;
        
        case 'Q':	 /* Show numeric states in -align mode output */
          if (args_info->show_states_given) {
            fprintf(stderr, "%s: `--show-states' (`-Q') option given more than once\n", PROGRAM);
          }
          args_info->show_states_given++;
         if (args_info->show_states_given <= 1)
           args_info->show_states_flag = !(args_info->show_states_flag);
          break;
        
        case 'a':	 /* Output in AT&T regex format. */
          if (args_info->att_given) {
            fprintf(stderr, "%s: `--att' (`-a') option given more than once\n", PROGRAM);
          }
          args_info->att_given++;
         if (args_info->att_given <= 1)
           args_info->att_flag = !(args_info->att_flag);
          break;
        
        case 'A':	 /* Output aligned arc paths. */
          if (args_info->align_given) {
            fprintf(stderr, "%s: `--align' (`-A') option given more than once\n", PROGRAM);
          }
          args_info->align_given++;
         if (args_info->align_given <= 1)
           args_info->align_flag = !(args_info->align_flag);
          break;
        
        case 'v':	 /* Treat input automaton as a Viterbi trellis. */
          if (args_info->viterbi_given) {
            fprintf(stderr, "%s: `--viterbi' (`-v') option given more than once\n", PROGRAM);
          }
          args_info->viterbi_given++;
         if (args_info->viterbi_given <= 1)
           args_info->viterbi_flag = !(args_info->viterbi_flag);
          break;
        
        case 'u':	 /* Assume UTF-8 encoded alphabet and input */
          if (args_info->utf8_given) {
            fprintf(stderr, "%s: `--utf8' (`-u') option given more than once\n", PROGRAM);
          }
          args_info->utf8_given++;
         if (args_info->utf8_given <= 1)
           args_info->utf8_flag = !(args_info->utf8_flag);
          break;
        
        case 'F':	 /* Output file. */
          if (args_info->output_given) {
            fprintf(stderr, "%s: `--output' (`-F') option given more than once\n", PROGRAM);
          }
          args_info->output_given++;
          if (args_info->output_arg) free(args_info->output_arg);
          args_info->output_arg = gog_strdup(val);
          break;
        
        case 0:	 /* Long option(s) with no short form */
        /* Print help and exit. */
          if (strcmp(olong, "help") == 0) {
            if (args_info->help_given) {
              fprintf(stderr, "%s: `--help' (`-h') option given more than once\n", PROGRAM);
            }
            clear_args(args_info);
            cmdline_parser_print_help();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Print version and exit. */
          else if (strcmp(olong, "version") == 0) {
            if (args_info->version_given) {
              fprintf(stderr, "%s: `--version' (`-V') option given more than once\n", PROGRAM);
            }
            clear_args(args_info);
            cmdline_parser_print_version();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Specify input (lower) labels file. */
          else if (strcmp(olong, "ilabels") == 0) {
            if (args_info->ilabels_given) {
              fprintf(stderr, "%s: `--ilabels' (`-i') option given more than once\n", PROGRAM);
            }
            args_info->ilabels_given++;
            if (args_info->ilabels_arg) free(args_info->ilabels_arg);
            args_info->ilabels_arg = gog_strdup(val);
          }
          
          /* Specify output (upper) labels file. */
          else if (strcmp(olong, "olabels") == 0) {
            if (args_info->olabels_given) {
              fprintf(stderr, "%s: `--olabels' (`-o') option given more than once\n", PROGRAM);
            }
            args_info->olabels_given++;
            if (args_info->olabels_arg) free(args_info->olabels_arg);
            args_info->olabels_arg = gog_strdup(val);
          }
          
          /* Set -i and -o labels simultaneously. */
          else if (strcmp(olong, "labels") == 0) {
            if (args_info->labels_given) {
              fprintf(stderr, "%s: `--labels' (`-l') option given more than once\n", PROGRAM);
            }
            args_info->labels_given++;
            if (args_info->labels_arg) free(args_info->labels_arg);
            args_info->labels_arg = gog_strdup(val);
          }
          
          /* Specify state labels file (for -align mode). */
          else if (strcmp(olong, "qlabels") == 0) {
            if (args_info->qlabels_given) {
              fprintf(stderr, "%s: `--qlabels' (`-q') option given more than once\n", PROGRAM);
            }
            args_info->qlabels_given++;
            if (args_info->qlabels_arg) free(args_info->qlabels_arg);
            args_info->qlabels_arg = gog_strdup(val);
          }
          
          /* Show numeric states in -align mode output */
          else if (strcmp(olong, "show-states") == 0) {
            if (args_info->show_states_given) {
              fprintf(stderr, "%s: `--show-states' (`-Q') option given more than once\n", PROGRAM);
            }
            args_info->show_states_given++;
           if (args_info->show_states_given <= 1)
             args_info->show_states_flag = !(args_info->show_states_flag);
          }
          
          /* Output in AT&T regex format. */
          else if (strcmp(olong, "att") == 0) {
            if (args_info->att_given) {
              fprintf(stderr, "%s: `--att' (`-a') option given more than once\n", PROGRAM);
            }
            args_info->att_given++;
           if (args_info->att_given <= 1)
             args_info->att_flag = !(args_info->att_flag);
          }
          
          /* Output aligned arc paths. */
          else if (strcmp(olong, "align") == 0) {
            if (args_info->align_given) {
              fprintf(stderr, "%s: `--align' (`-A') option given more than once\n", PROGRAM);
            }
            args_info->align_given++;
           if (args_info->align_given <= 1)
             args_info->align_flag = !(args_info->align_flag);
          }
          
          /* Treat input automaton as a Viterbi trellis. */
          else if (strcmp(olong, "viterbi") == 0) {
            if (args_info->viterbi_given) {
              fprintf(stderr, "%s: `--viterbi' (`-v') option given more than once\n", PROGRAM);
            }
            args_info->viterbi_given++;
           if (args_info->viterbi_given <= 1)
             args_info->viterbi_flag = !(args_info->viterbi_flag);
          }
          
          /* Assume UTF-8 encoded alphabet and input */
          else if (strcmp(olong, "utf8") == 0) {
            if (args_info->utf8_given) {
              fprintf(stderr, "%s: `--utf8' (`-u') option given more than once\n", PROGRAM);
            }
            args_info->utf8_given++;
           if (args_info->utf8_given <= 1)
             args_info->utf8_flag = !(args_info->utf8_flag);
          }
          
          /* Output file. */
          else if (strcmp(olong, "output") == 0) {
            if (args_info->output_given) {
              fprintf(stderr, "%s: `--output' (`-F') option given more than once\n", PROGRAM);
            }
            args_info->output_given++;
            if (args_info->output_arg) free(args_info->output_arg);
            args_info->output_arg = gog_strdup(val);
          }
          
          else {
            fprintf(stderr, "%s: unknown long option '%s'.\n", PROGRAM, olong);
            return (EXIT_FAILURE);
          }
          break;

        case '?':	 /* Invalid Option */
          fprintf(stderr, "%s: unknown option '%s'.\n", PROGRAM, olong);
          return (EXIT_FAILURE);


        default:	/* bug: options not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PROGRAM, oshort);
          abort ();
        } /* switch */
  return 0;
}


/* Initialize options not yet given from environmental defaults */
void
cmdline_parser_envdefaults(struct gengetopt_args_info *args_info)
{
  

  return;
}


/* Load option values from an .rc file */
void
cmdline_parser_read_rcfile(const char *filename,
			      struct gengetopt_args_info *args_info,
			      int user_specified)
{
  char *fullname;
  FILE *rcfile;

  if (!filename) return; /* ignore NULL filenames */

#if defined(HAVE_GETUID) && defined(HAVE_GETPWUID)
  if (*filename == '~') {
    /* tilde-expansion hack */
    struct passwd *pwent = getpwuid(getuid());
    if (!pwent) {
      fprintf(stderr, "%s: user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    if (!pwent->pw_dir) {
      fprintf(stderr, "%s: home directory for user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    fullname = (char *)malloc(strlen(pwent->pw_dir)+strlen(filename));
    strcpy(fullname, pwent->pw_dir);
    strcat(fullname, filename+1);
  } else {
    fullname = gog_strdup(filename);
  }
#else /* !(defined(HAVE_GETUID) && defined(HAVE_GETPWUID)) */
  fullname = gog_strdup(filename);
#endif /* defined(HAVE_GETUID) && defined(HAVE_GETPWUID) */

  /* try to open */
  rcfile = fopen(fullname,"r");
  if (!rcfile) {
    if (user_specified) {
      fprintf(stderr, "%s: warning: open failed for rc-file '%s': %s\n",
	      PROGRAM, fullname, strerror(errno));
    }
  }
  else {
   cmdline_parser_read_rc_stream(rcfile, fullname, args_info);
  }

  /* cleanup */
  if (fullname != filename) free(fullname);
  if (rcfile) fclose(rcfile);

  return;
}


/* Parse option values from an .rc file : guts */
#define OPTPARSE_GET 32
void
cmdline_parser_read_rc_stream(FILE *rcfile,
				 const char *filename,
				 struct gengetopt_args_info *args_info)
{
  char *optname  = (char *)malloc(OPTPARSE_GET);
  char *optval   = (char *)malloc(OPTPARSE_GET);
  size_t onsize  = OPTPARSE_GET;
  size_t ovsize  = OPTPARSE_GET;
  size_t onlen   = 0;
  size_t ovlen   = 0;
  int    lineno  = 0;
  char c;

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "cmdline_parser_read_rc_stream('%s'):\n", filename);
#endif

  while ((c = fgetc(rcfile)) != EOF) {
    onlen = 0;
    ovlen = 0;
    lineno++;

    /* -- get next option-name */
    /* skip leading space and comments */
    if (isspace(c)) continue;
    if (c == '#') {
      while ((c = fgetc(rcfile)) != EOF) {
	if (c == '\n') break;
      }
      continue;
    }

    /* parse option-name */
    while (c != EOF && c != '=' && !isspace(c)) {
      /* re-allocate if necessary */
      if (onlen >= onsize-1) {
	char *tmp = (char *)malloc(onsize+OPTPARSE_GET);
	strcpy(tmp,optname);
	free(optname);

	onsize += OPTPARSE_GET;
	optname = tmp;
      }
      optname[onlen++] = c;
      c = fgetc(rcfile);
    }
    optname[onlen++] = '\0';

#ifdef cmdline_parser_DEBUG
    fprintf(stderr, "cmdline_parser_read_rc_stream('%s'): line %d: optname='%s'\n",
	    filename, lineno, optname);
#endif

    /* -- get next option-value */
    /* skip leading space */
    while ((c = fgetc(rcfile)) != EOF && isspace(c)) {
      ;
    }

    /* parse option-value */
    while (c != EOF && c != '\n') {
      /* re-allocate if necessary */
      if (ovlen >= ovsize-1) {
	char *tmp = (char *)malloc(ovsize+OPTPARSE_GET);
	strcpy(tmp,optval);
	free(optval);
	ovsize += OPTPARSE_GET;
	optval = tmp;
      }
      optval[ovlen++] = c;
      c = fgetc(rcfile);
    }
    optval[ovlen++] = '\0';

    /* now do the action for the option */
    if (cmdline_parser_parse_option('\0',optname,optval,args_info) != 0) {
      fprintf(stderr, "%s: error in file '%s' at line %d.\n", PROGRAM, filename, lineno);
      
    }
  }

  /* cleanup */
  free(optname);
  free(optval);

  return;
}
